'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _snackbarActions = require('../../state/snackbarActions');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Snackbar = function (_React$Component) {
	_inherits(Snackbar, _React$Component);

	function Snackbar() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Snackbar);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Snackbar.__proto__ || Object.getPrototypeOf(Snackbar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			snack: null,
			visible: false
		}, _this.showSnack = function (snack) {
			_this.hideSnack().then(function () {
				_this.setState({ snack: snack, visible: false });
				setTimeout(function () {
					_this.setState({ visible: true });
					if (snack.data.timeout) {
						_this.snackTimer = setTimeout(function () {
							_this.props.dispatch((0, _snackbarActions.dismissSnack)(snack.id));
						}, snack.data.timeout);
					}
				}, 1);
			});
		}, _this.hideSnack = function () {
			if (!_this.state.snack) {
				return Promise.resolve();
			}
			return new Promise(function (resolve) {
				_this.clearDismissTimer();
				_this.setState({ visible: false });
				_this.afterTransition = function () {
					_this.setState({ snack: null });
					resolve();
				};
			});
		}, _this.clearDismissTimer = function () {
			if (_this.snackTimer) {
				clearTimeout(_this.snackTimer);
				_this.snackTimer = null;
			}
		}, _this.transitionEndHandler = function () {
			if (_this.afterTransition) {
				_this.afterTransition();
				_this.afterTransition = null;
			}
		}, _this.buttonClickHandler = function () {
			var onButtonClick = _this.props.onButtonClick;
			var snack = _this.state.snack;
			var id = snack.id,
			    _snack$data$button = snack.data.button,
			    button = _snack$data$button === undefined ? {} : _snack$data$button;


			if (onButtonClick) {
				onButtonClick(snack);
			} else if (button.action && typeof button.action === 'function') {
				button.action(snack);
			} else if (button.action && typeof button.action.type === 'string') {
				_this.props.dispatch(button.action);
			} else if (button.action === 'redirect' && button.href) {
				window.location.href = button.href;
			}

			_this.props.dispatch((0, _snackbarActions.dismissSnack)(id));
		}, _this.populateStyles = function (elem) {
			var _this$props = _this.props,
			    theming = _this$props.theming,
			    customStyles = _this$props.customStyles;

			var largeScreen = window.matchMedia('(min-width: 720px)').matches;
			return (0, _styles2.default)(elem, largeScreen, _this.state.visible, theming, customStyles);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Snackbar, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			if (this.props.snack) {
				this.showSnack(this.props.snack);
			}
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			var snack = this.props.snack;
			var nextSnack = nextProps.snack;
			var visibleSnack = this.state.snack;
			var isInactive = this.props.inactive;
			var willInactivate = nextProps.inactive;
			if (!willInactivate && (nextSnack && !snack || nextSnack && nextSnack.id !== (snack || {}).id)) {
				this.showSnack(nextSnack); // Active, and a new snack stands in line in the queue. Show it!
			} else if (isInactive && !willInactivate && snack && !visibleSnack) {
				this.showSnack(snack); // Will be active, and we have a snack. Show it!
			} else if (!isInactive && willInactivate && visibleSnack) {
				this.hideSnack(); // Will deactivate, remove the snack until we become active again
			} else if (!nextSnack && snack) {
				this.hideSnack(); // The current snack has been removed from the queue, no one stands in line. Hide it!
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.clearDismissTimer();
		}
	}, {
		key: 'render',
		value: function render() {
			var snack = this.state.snack;

			if (!snack) {
				return null;
			}
			var button = (snack.data.button || {}).label ? snack.data.button : null;
			return _react2.default.createElement(
				'div',
				{
					style: this.populateStyles('snack'),
					onTransitionEnd: this.transitionEndHandler
				},
				_react2.default.createElement(
					'span',
					{ style: this.populateStyles('label') },
					snack.data.label
				),
				button && _react2.default.createElement(
					'button',
					{
						style: this.populateStyles('button'),
						onClick: this.buttonClickHandler
					},
					button.label
				)
			);
		}
	}]);

	return Snackbar;
}(_react2.default.Component);

exports.default = (0, _reactRedux.connect)(function (state) {
	return { snack: state.snackbar.queue[0] || null };
})(Snackbar);